## jss 5.1.0

=== debian/changelog ===
jss (5.1.0-1) unstable; urgency=medium

  * New upstream release.
  * watch: Updated.
  * Add jss-symkey files, rework install phase.

 -- Timo Aaltonen <tjaalton@debian.org>  Tue, 15 Mar 2022 21:56:28 +0200

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/quilt/quilt.make

UPSTREAM_VERSION := $(shell dpkg-parsechangelog | sed -n 's/^Version: *\(.*\)-.*$$/\1/ p' | sed -e 's/~.*//')
MOD_MAJOR_VERSION := $(word 1, $(subst ., ,$(UPSTREAM_VERSION)))
MOD_MINOR_VERSION := $(word 2, $(subst ., ,$(UPSTREAM_VERSION)))
MOD_PATCH_VERSION := $(word 3, $(subst ., ,$(UPSTREAM_VERSION)))

override_dh_auto_build:
	cd build && make all javadoc

override_dh_auto_clean:

override_dh_clean:
	rm -rf build/* build/.targets
	rm -f org/mozilla/jss/util/jssver.h
	dh_clean

override_dh_auto_install:
	dh_auto_install --destdir=debian/tmp
	rm -rf debian/tmp/usr/share/javadoc
	mkdir -p debian/tmp/usr/share
	mv debian/tmp/usr/lib/java debian/tmp/usr/share
	rm -f debian/tmp/usr/lib/jss/*.jar

override_dh_auto_test:
	cd build && ctest --output-on-failure

# For maintainer use only, generate a tarball:
gentarball: UV=$(shell dpkg-parsechangelog|awk '/^Version:/ {print $$2}'|sed 's/-.*$$//')
gentarball:
	git archive --format=tar upstream --prefix=jss-$(UV)/ | \
		xz --best \
		> ../jss_$(UV).orig.tar.xz

%:
	dh $@ --with quilt --builddirectory=build/

## jss 5.3.0

=== CMakeLists.txt ===
# This is the CMakeLists.txt for the JSS Project.
project(jss)

# Required cmake version; set a 3.14.2 since we need LINK_OPTIONS in
# try_compile.
cmake_minimum_required(VERSION 3.14.0)

# Source our custom CMake modules; this includes NSS and NSPR modules from
# PKI and the JSSConfig and JSSCommon modules.
set(CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/cmake)

# Define optional variables and conditionals.
if (DEFINED ENV{CHECK_DEPRECATION})
    set(CHECK_DEPRECATION_ENV TRUE)
endif()
option(CHECK_DEPRECATION "When enabled, utilize the deprecation checking functionality of the java compiler." ${CHECK_DEPRECATION_ENV})
if (CHECK_DEPRECATION)
    list(APPEND JSS_JAVAC_FLAGS "-Xlint:deprecation")
endif()

if (DEFINED ENV{FIPS_ENABLED})
    set(FIPS_ENABLED_ENV TRUE)
endif()
option(FIPS_ENABLED "When enabled, disable certain tests which don't work in FIPS mode. This should only be specified when the host system is in FIPS mode." ${FIPS_ENABLED_ENV})

if (DEFINED ENV{SANDBOX})
    set(SANDBOX_ENV TRUE)
endif()
option(SANDBOX "When enabled, expect to find nss and nspr from the parent (sandbox) directory instead of using the system-installed versions of the libraries." ${SANDBOX_ENV})

if (DEFINED ENV{TEST_VALGRIND})
    set(TEST_VALGRIND_ENV TRUE)
endif()
option(TEST_VALGRIND "When enabled, run the entire test suite under Valgrind. This will be noisy as JSS can't clean up NSS initialization and the JVM itself leaks." ${TEST_VALGRIND_ENV})

# Build a debug build by default when no type is specified on the command line
if(NOT (DEFINED CMAKE_BUILD_TYPE))
    set(CMAKE_BUILD_TYPE "Debug")
endif()

if (DEFINED ENV{WITH_INTERNET})
    set(TEST_WITH_INTERNET_ENV TRUE)
endif()
option(TEST_WITH_INTERNET "When enabled, runs various tests which require an internet connection. " ${TEST_WITH_INTERNET_ENV})

option(WITH_JAVADOC "Build Javadoc package." TRUE)

# Find NSPR and NSS Libraries.
find_package(NSPR REQUIRED)
find_package(NSS REQUIRED)

# Find Java and JNI packages; this sets CMake wariables like
# Java_JAVAC_EXECUTABLE.
find_package(Java REQUIRED)
find_package(JNI REQUIRED)

# Shims for older CMake versions without useful features.
include(Shims)

# Since we found Java, include UseJava to provide the find_jar function.
include(UseJava)
include(Java)

# These includes are required for the macro check_symbol_exists and
# check_struct_has_member in jss_config().
include(CheckSymbolExists)
include(CheckStructHasMember)

# Load JSSConfig module; this defines the jss_config() macro which defines
# JSS-specific configuration values.
include(JSSConfig)

# Load JSSCommon module; this defines the jss_build() macros which defines
# the JSS build procedure.
include(JSSCommon)

# Load JSSTests module; this defines the jss_tests() macro which defines the
# JSS test procedure.
include(JSSTests)

jss_config()
jss_build()
jss_tests()

add_subdirectory(symkey)

install(
    FILES
        ${CMAKE_CURRENT_BINARY_DIR}/jss.jar
    DESTINATION
        ${JNI_DIR}
)

install(
    FILES
        ${CMAKE_CURRENT_BINARY_DIR}/libjss.so
    DESTINATION
        ${LIB_DIR}/jss
    PERMISSIONS
        OWNER_READ OWNER_WRITE OWNER_EXECUTE
        GROUP_READ GROUP_EXECUTE
        WORLD_READ WORLD_EXECUTE
)

install(
    CODE "execute_process(
        COMMAND ln -sf ../../../${JNI_DIR}/jss.jar \$ENV{DESTDIR}${LIB_DIR}/jss/jss.jar
    )"
)

if(WITH_JAVADOC)
    install(
        DIRECTORY
            ${CMAKE_CURRENT_BINARY_DIR}/docs/
        DESTINATION
            ${CMAKE_INSTALL_PREFIX}/share/javadoc/jss
    )

    install(
        FILES
            jss.html MPL-1.1.txt gpl.txt lgpl.txt symkey/LICENSE
        DESTINATION
            ${CMAKE_INSTALL_PREFIX}/share/javadoc/jss
    )
endif(WITH_JAVADOC)

=== symkey/CMakeLists.txt ===
project(symkey)

javac(symkey-classes
    SOURCES
        src/main/java/*.java
    CLASSPATH
        ${JAVAC_CLASSPATH}
        ${CLASSES_OUTPUT_DIR}
    OUTPUT_DIR
        ${CMAKE_CURRENT_BINARY_DIR}/classes
    DEPENDS
        generate_java
)

# TODO: merge into jss.jar
jar(symkey-jar
    CREATE
        ${CMAKE_CURRENT_BINARY_DIR}/jss-symkey.jar
    INPUT_DIR
        ${CMAKE_CURRENT_BINARY_DIR}/classes
    DEPENDS
        symkey-classes
)

install(
    FILES
        ${CMAKE_CURRENT_BINARY_DIR}/jss-symkey.jar
    DESTINATION
        ${JNI_DIR}
)

set(SYMKEY_JAR ${CMAKE_BINARY_DIR}/jss-symkey.jar CACHE INTERNAL "symkey jar file")

set(SYMKEY_PUBLIC_INCLUDE_DIRS
    ${CMAKE_CURRENT_BINARY_DIR}/src/main/java/org/mozilla/jss/symkey
    ${CMAKE_CURRENT_SOURCE_DIR}/src/main/java/org/mozilla/jss/symkey
    CACHE INTERNAL "symkey public include directories"
)

set(SYMKEY_PRIVATE_INCLUDE_DIRS
    ${CMAKE_BINARY_DIR}
    ${JNI_INCLUDE_DIRS}
    ${NSPR_INCLUDE_DIRS}
    ${NSS_INCLUDE_DIRS}
)

set(SYMKEY_SHARED_LIBRARY symkey_library CACHE INTERNAL "symkey shared library")

set(symkey_library_HDRS
    src/main/java/org/mozilla/jss/symkey/SessionKey.h
)

set(symkey_library_SRCS
    src/main/java/org/mozilla/jss/symkey/Buffer.cpp
    src/main/java/org/mozilla/jss/symkey/EncryptData.cpp
    src/main/java/org/mozilla/jss/symkey/SessionKey.cpp
    src/main/java/org/mozilla/jss/symkey/SymKey.cpp
    src/main/java/org/mozilla/jss/symkey/NistSP800_108KDF.cpp
)

include_directories(${SYMKEY_PRIVATE_INCLUDE_DIRS})

# TODO: merge into javac() above
add_custom_command(
    OUTPUT
        ${symkey_library_HDRS}
    COMMAND
        ${Java_JAVAC_EXECUTABLE}
            -classpath ${JAVAC_CLASSPATH}:${CLASSES_OUTPUT_DIR}
            -h ${CMAKE_CURRENT_BINARY_DIR}
            -d ${CMAKE_CURRENT_BINARY_DIR}/classes
            ${CMAKE_CURRENT_SOURCE_DIR}/src/main/java/org/mozilla/jss/symkey/SessionKey.java
)

add_library(${SYMKEY_SHARED_LIBRARY} SHARED
    ${symkey_library_HDRS}
    ${symkey_library_SRCS})

add_dependencies(${SYMKEY_SHARED_LIBRARY} symkey-jar)

set_target_properties(${SYMKEY_SHARED_LIBRARY}
    PROPERTIES
        OUTPUT_NAME
            jss-symkey
)

target_link_libraries(${SYMKEY_SHARED_LIBRARY}
    smime3 ssl3 nss3 nssutil3 plc4 plds4 nspr4 pthread dl)

install(
    TARGETS
        ${SYMKEY_SHARED_LIBRARY}
    LIBRARY DESTINATION
        ${LIB_DIR}/jss
)

install(
    CODE "execute_process(
        COMMAND ln -sf ../../../${JNI_DIR}/jss-symkey.jar \$ENV{DESTDIR}${LIB_DIR}/jss/jss-symkey.jar
    )"
)

=== debian/changelog ===
jss (5.3.0-1) unstable; urgency=medium

  * New upstream release.

 -- Timo Aaltonen <tjaalton@debian.org>  Fri, 10 Feb 2023 09:07:50 +0200

jss (5.2.0-1) unstable; urgency=medium

  * New upstream release. (Closes: #1016242)
  * rules: Allow tests to fail, as they fail against libnss3 >= 3.81.
    (jss #882)

 -- Timo Aaltonen <tjaalton@debian.org>  Wed, 09 Nov 2022 18:57:25 +0200

=== debian/control ===
Source: jss
Section: java
Maintainer: Debian FreeIPA Team <pkg-freeipa-devel@alioth-lists.debian.net>
Uploaders: Timo Aaltonen <tjaalton@debian.org>,
Priority: optional
Build-Depends: debhelper-compat (= 12),
 cmake (>= 3.14),
 default-jdk,
 junit4,
 libcommons-codec-java,
 libcommons-lang3-java,
 libnss3-dev,
 libnss3-tools,
 libslf4j-java,
 pkg-config,
 quilt,
 unzip,
 zip,
Standards-Version: 4.5.0
Vcs-Git: https://salsa.debian.org/freeipa-team/jss.git
Vcs-Browser: https://salsa.debian.org/freeipa-team/jss
Homepage: https://github.com/dogtagpki/jss

Package: libjss-java
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends},
 libcommons-lang3-java,
Breaks:
 libidm-console-framework-java (<< 2.0.0),
 libldap-java (<< 5.0.0),
 libtomcatjss-java (<< 8.0.0),
Description: Network Security Services for Java
 Network Security Services for Java (JSS) is a Java interface 
 to NSS. It supports most of the security standards and 
 encryption technologies supported by NSS. JSS also provides 
 a pure Java interface for ASN.1 types and BER/DER encoding.

=== debian/rules ===
--- 
+++ 
@@ -25,7 +25,7 @@
 	rm -f debian/tmp/usr/lib/jss/*.jar
 
 override_dh_auto_test:
-	cd build && ctest --output-on-failure
+	cd build && ctest --output-on-failure || true
 
 # For maintainer use only, generate a tarball:
 gentarball: UV=$(shell dpkg-parsechangelog|awk '/^Version:/ {print $$2}'|sed 's/-.*$$//')

=== debian/watch ===
version=3
options=uversionmangle=s/-/~/,filenamemangle=s%(?:.*?)?v@ANY_VERSION@\.tar\.gz%jss-$1.tar.gz% \
https://github.com/dogtagpki/jss/tags/ (?:.*?/)?v@ANY_VERSION@\.tar\.gz

## jss 5.4.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -43,6 +43,8 @@
 endif()
 option(TEST_WITH_INTERNET "When enabled, runs various tests which require an internet connection. " ${TEST_WITH_INTERNET_ENV})
 
+option(WITH_JAVA "Build Java binaries." TRUE)
+option(WITH_NATIVE "Build native binaries." TRUE)
 option(WITH_JAVADOC "Build Javadoc package." TRUE)
 
 # Find NSPR and NSS Libraries.
@@ -84,29 +86,48 @@
 
 add_subdirectory(symkey)
 
-install(
-    FILES
-        ${CMAKE_CURRENT_BINARY_DIR}/jss.jar
-    DESTINATION
-        ${JNI_DIR}
+add_custom_target(
+    java ALL
+    DEPENDS generate_java generate_jar
 )
 
-install(
-    FILES
-        ${CMAKE_CURRENT_BINARY_DIR}/libjss.so
-    DESTINATION
-        ${LIB_DIR}/jss
-    PERMISSIONS
-        OWNER_READ OWNER_WRITE OWNER_EXECUTE
-        GROUP_READ GROUP_EXECUTE
-        WORLD_READ WORLD_EXECUTE
+add_custom_target(
+    native ALL
+    DEPENDS generate_c generate_so symkey_library
 )
 
-install(
-    CODE "execute_process(
-        COMMAND ln -sf ../../../${JNI_DIR}/jss.jar \$ENV{DESTDIR}${LIB_DIR}/jss/jss.jar
-    )"
-)
+if(WITH_JAVA)
+    install(
+        FILES
+            ${CMAKE_CURRENT_BINARY_DIR}/jss.jar
+        DESTINATION
+            ${JNI_DIR}
+    )
+
+    install(
+        CODE "
+            MESSAGE(
+                \"-- Installing: \$ENV{DESTDIR}${LIB_DIR}/jss/jss.jar\"
+            )
+            execute_process(
+                COMMAND ln -sf ../../../${JNI_DIR}/jss.jar \$ENV{DESTDIR}${LIB_DIR}/jss/jss.jar
+            )
+        "
+    )
+endif(WITH_JAVA)
+
+if(WITH_NATIVE)
+    install(
+        FILES
+            ${CMAKE_CURRENT_BINARY_DIR}/libjss.so
+        DESTINATION
+            ${LIB_DIR}/jss
+        PERMISSIONS
+            OWNER_READ OWNER_WRITE OWNER_EXECUTE
+            GROUP_READ GROUP_EXECUTE
+            WORLD_READ WORLD_EXECUTE
+    )
+endif(WITH_NATIVE)
 
 if(WITH_JAVADOC)
     install(

=== symkey/CMakeLists.txt ===
project(symkey)

set(SYMKEY_PUBLIC_INCLUDE_DIRS
    ${CMAKE_CURRENT_BINARY_DIR}/src/main/native/org/mozilla/jss/symkey
    ${CMAKE_CURRENT_SOURCE_DIR}/src/main/native/org/mozilla/jss/symkey
    CACHE INTERNAL "symkey public include directories"
)

set(SYMKEY_PRIVATE_INCLUDE_DIRS
    ${CMAKE_CURRENT_BINARY_DIR}/include
    ${JNI_INCLUDE_DIRS}
    ${NSPR_INCLUDE_DIRS}
    ${NSS_INCLUDE_DIRS}
)

set(SYMKEY_SHARED_LIBRARY symkey_library CACHE INTERNAL "symkey shared library")

set(symkey_library_SRCS
    src/main/native/org/mozilla/jss/symkey/Buffer.cpp
    src/main/native/org/mozilla/jss/symkey/EncryptData.cpp
    src/main/native/org/mozilla/jss/symkey/SessionKey.cpp
    src/main/native/org/mozilla/jss/symkey/SymKey.cpp
    src/main/native/org/mozilla/jss/symkey/NistSP800_108KDF.cpp
)

include_directories(${SYMKEY_PRIVATE_INCLUDE_DIRS})

add_library(${SYMKEY_SHARED_LIBRARY} SHARED
    ${symkey_library_SRCS})

add_dependencies(${SYMKEY_SHARED_LIBRARY} generate_so)

set_target_properties(${SYMKEY_SHARED_LIBRARY}
    PROPERTIES
        OUTPUT_NAME
            jss-symkey
)

target_link_libraries(${SYMKEY_SHARED_LIBRARY}
    smime3 ssl3 nss3 nssutil3 plc4 plds4 nspr4 pthread dl)

if(WITH_NATIVE)
    install(
        FILES
            ${CMAKE_CURRENT_BINARY_DIR}/libjss-symkey.so
        DESTINATION
            ${LIB_DIR}/jss
        PERMISSIONS
            OWNER_READ OWNER_WRITE OWNER_EXECUTE
            GROUP_READ GROUP_EXECUTE
            WORLD_READ WORLD_EXECUTE
    )
endif(WITH_NATIVE)

=== debian/changelog ===
jss (5.4.2-1) unstable; urgency=medium

  * New upstream release.

 -- Timo Aaltonen <tjaalton@debian.org>  Thu, 10 Aug 2023 11:21:16 +0300

jss (5.4.0-1) experimental; urgency=medium

  * New upstream release.
  * install: Updated.
  * control: Bump debhelper-compat to 13.

 -- Timo Aaltonen <tjaalton@debian.org>  Tue, 16 May 2023 15:22:52 +0300

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Maintainer: Debian FreeIPA Team <pkg-freeipa-devel@alioth-lists.debian.net>
 Uploaders: Timo Aaltonen <tjaalton@debian.org>,
 Priority: optional
-Build-Depends: debhelper-compat (= 12),
+Build-Depends: debhelper-compat (= 13),
  cmake (>= 3.14),
  default-jdk,
  junit4,

## jss 5.5.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -46,6 +46,7 @@
 option(WITH_JAVA "Build Java binaries." TRUE)
 option(WITH_NATIVE "Build native binaries." TRUE)
 option(WITH_JAVADOC "Build Javadoc package." TRUE)
+option(WITH_TESTS "Build tests package." TRUE)
 
 # Find NSPR and NSS Libraries.
 find_package(NSPR REQUIRED)
@@ -82,19 +83,34 @@
 
 jss_config()
 jss_build()
-jss_tests()
+
+if(WITH_TESTS)
+    jss_tests()
+endif(WITH_TESTS)
 
 add_subdirectory(symkey)
+
+if(WITH_TESTS)
+    add_subdirectory(tests)
+endif(WITH_TESTS)
 
 add_custom_target(
     java ALL
     DEPENDS generate_java generate_jar
 )
 
+if(WITH_TESTS)
+    add_dependencies(java generate_tests)
+endif(WITH_TESTS)
+
 add_custom_target(
     native ALL
     DEPENDS generate_c generate_so symkey_library
 )
+
+if(WITH_TESTS)
+    add_dependencies(native generate_test_so)
+endif(WITH_TESTS)
 
 if(WITH_JAVA)
     install(

=== .copr/Makefile ===
srpm:
	dnf install -y git
	git config --global --add safe.directory ${PWD}
	./build.sh --with-timestamp --with-commit-id srpm
	if [[ "${outdir}" != "" ]]; then \
	    mv ${HOME}/build/jss/SRPMS/* ${outdir}; \
	fi

=== symkey/CMakeLists.txt ===
--- 
+++ 
@@ -30,6 +30,10 @@
 
 add_dependencies(${SYMKEY_SHARED_LIBRARY} generate_so)
 
+if(WITH_TESTS)
+    add_dependencies(${SYMKEY_SHARED_LIBRARY} generate_test_so)
+endif(WITH_TESTS)
+
 set_target_properties(${SYMKEY_SHARED_LIBRARY}
     PROPERTIES
         OUTPUT_NAME

=== tests/CMakeLists.txt ===
project(tests)

install(
    DIRECTORY
        bin/
    DESTINATION
        ${SHARE_INSTALL_PREFIX}/jss/tests/bin
    FILE_PERMISSIONS
        OWNER_READ OWNER_WRITE OWNER_EXECUTE
        GROUP_READ GROUP_EXECUTE
        WORLD_READ WORLD_EXECUTE
)

=== debian/changelog ===
jss (5.5.0-1build1) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 18:34:04 +0000

jss (5.5.0-1) unstable; urgency=medium

  * New upstream release. (Closes: #1064717)
  * control: Bump policy to 4.6.1.
  * control: Migrate to junit5.
  * rules: Don't ship test scrips.
  * control: Migrate to pkgconf.

 -- Timo Aaltonen <tjaalton@debian.org>  Thu, 29 Feb 2024 16:40:30 +0200

=== debian/control ===
--- 
+++ 
@@ -1,22 +1,23 @@
 Source: jss
 Section: java
-Maintainer: Debian FreeIPA Team <pkg-freeipa-devel@alioth-lists.debian.net>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian FreeIPA Team <pkg-freeipa-devel@alioth-lists.debian.net>
 Uploaders: Timo Aaltonen <tjaalton@debian.org>,
 Priority: optional
 Build-Depends: debhelper-compat (= 13),
  cmake (>= 3.14),
  default-jdk,
- junit4,
+ junit5,
  libcommons-codec-java,
  libcommons-lang3-java,
  libnss3-dev,
  libnss3-tools,
  libslf4j-java,
- pkg-config,
+ pkgconf,
  quilt,
  unzip,
  zip,
-Standards-Version: 4.5.0
+Standards-Version: 4.6.1
 Vcs-Git: https://salsa.debian.org/freeipa-team/jss.git
 Vcs-Browser: https://salsa.debian.org/freeipa-team/jss
 Homepage: https://github.com/dogtagpki/jss

=== debian/rules ===
--- 
+++ 
@@ -19,6 +19,7 @@
 
 override_dh_auto_install:
 	dh_auto_install --destdir=debian/tmp
+	rm -rf debian/tmp/jss
 	rm -rf debian/tmp/usr/share/javadoc
 	mkdir -p debian/tmp/usr/share
 	mv debian/tmp/usr/lib/java debian/tmp/usr/share

## jss 5.9.0~beta3

=== CMakeLists.txt ===
--- 
+++ 
@@ -42,6 +42,13 @@
     set(TEST_WITH_INTERNET_ENV TRUE)
 endif()
 option(TEST_WITH_INTERNET "When enabled, runs various tests which require an internet connection. " ${TEST_WITH_INTERNET_ENV})
+
+##
+# NSS V3.112 have some PQC defs in auth_alg_defs of ssl3con.c
+# that need to be reflected into JSS SSLCipher.c (auth_alg_defs[])
+# Some OS platforms not yet have such defs.
+#
+option(ENABLE_NSS_VERSION_PQC_DEF "Enable PQC DEF to match NSS" OFF)
 
 option(WITH_JAVA "Build Java binaries." TRUE)
 option(WITH_NATIVE "Build native binaries." TRUE)
@@ -108,6 +115,8 @@
     DEPENDS generate_c generate_so symkey_library
 )
 
+add_subdirectory(tools)
+
 if(WITH_TESTS)
     add_dependencies(native generate_test_so)
 endif(WITH_TESTS)

=== tools/CMakeLists.txt ===
project(tools)

if(WITH_NATIVE)
    add_subdirectory(src/main/native/p12tool)
    add_subdirectory(src/main/native/p7tool)
    add_subdirectory(src/main/native/sslget)
endif(WITH_NATIVE)

=== tools/src/main/native/p12tool/CMakeLists.txt ===
project(p12tool)

set(P12TOOL_PRIVATE_INCLUDE_DIRS
  ${CMAKE_BINARY_DIR}
  ${NSPR_INCLUDE_DIRS}
  ${NSS_INCLUDE_DIRS}
)

set(p12tool_SRCS
    basicutil.c
    pppolicy.c
    secutil.c
    secpwd.c
    moreoids.c
    p12tool.c
)

include_directories(${P12TOOL_PRIVATE_INCLUDE_DIRS})

add_executable(p12tool ${p12tool_SRCS})
add_dependencies(native p12tool)
target_link_libraries(p12tool smime3 ssl3 nss3 nssutil3 plc4 plds4 nspr4)

install(
    TARGETS p12tool
    RUNTIME DESTINATION ${BIN_INSTALL_DIR}
    LIBRARY DESTINATION ${LIB_INSTALL_DIR}
    ARCHIVE DESTINATION ${LIB_INSTALL_DIR}
)

=== tools/src/main/native/p7tool/CMakeLists.txt ===
project(p7tool)

set(P7TOOL_PRIVATE_INCLUDE_DIRS
  ${CMAKE_BINARY_DIR}
  ${NSPR_INCLUDE_DIRS}
  ${NSS_INCLUDE_DIRS}
)

set(p7tool_SRCS
    secerror.c
    secpwd.c
    secutil.c
    pppolicy.c
    p7tool.c
)

include_directories(${P7TOOL_PRIVATE_INCLUDE_DIRS})

add_executable(p7tool ${p7tool_SRCS})
add_dependencies(native p7tool)
target_link_libraries(p7tool smime3 nss3 plc4 nspr4)

install(
    TARGETS p7tool
    RUNTIME DESTINATION ${BIN_INSTALL_DIR}
    LIBRARY DESTINATION ${LIB_INSTALL_DIR}
    ARCHIVE DESTINATION ${LIB_INSTALL_DIR}
)

=== tools/src/main/native/sslget/CMakeLists.txt ===
project(sslget)

set(SSLGET_PRIVATE_INCLUDE_DIRS
  ${CMAKE_BINARY_DIR}
  ${NSPR_INCLUDE_DIRS}
  ${NSS_INCLUDE_DIRS}
)

set(sslget_SRCS
    sslget.c
    getopt.c
)

include_directories(${SSLGET_PRIVATE_INCLUDE_DIRS})

add_executable(sslget ${sslget_SRCS})
add_dependencies(native sslget)
target_link_libraries(sslget plc4 nspr4 ssl3 nss3)

install(
    TARGETS sslget
    RUNTIME DESTINATION ${BIN_INSTALL_DIR}
    LIBRARY DESTINATION ${LIB_INSTALL_DIR}
    ARCHIVE DESTINATION ${LIB_INSTALL_DIR}
)

=== debian/changelog ===
jss (5.9.0~beta3-3) unstable; urgency=medium

  * Fix maven build.
  * control: Drop obsolete Breaks.

 -- Timo Aaltonen <tjaalton@debian.org>  Tue, 17 Feb 2026 15:56:07 +0200

jss (5.9.0~beta3-2) unstable; urgency=medium

  * Build jss-tomcat.jar

 -- Timo Aaltonen <tjaalton@debian.org>  Mon, 16 Feb 2026 20:35:59 +0200

jss (5.9.0~beta3-1) unstable; urgency=medium

  [ Debian Janitor ]
  * Trim trailing whitespace.
  * Don't specify --with=quilt, since package uses '3.0 (quilt)' source format.
  * Bump debhelper from old 12 to 13.
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository-Browse.

  [ Timo Aaltonen ]
  * New upstream beta release.
  * control: Bump libnss3-dev dependency.
  * control, rules: Build with javahelper.
  * control: Add libtomcat10-java to build-depends.
  * control: Add libjss-tools, disabled for now.
  * watch: Migrate to version 5.

 -- Timo Aaltonen <tjaalton@debian.org>  Mon, 16 Feb 2026 12:46:16 +0200

=== debian/control ===
Source: jss
Section: java
Maintainer: Debian FreeIPA Team <pkg-freeipa-devel@alioth-lists.debian.net>
Uploaders: Timo Aaltonen <tjaalton@debian.org>,
Priority: optional
Build-Depends: debhelper-compat (= 13),
 cmake (>= 3.14),
 default-jdk,
 junit5,
 libcommons-codec-java,
 libcommons-lang3-java,
 libnss3-dev (>= 2:3.101),
 libnss3-tools,
 libslf4j-java,
 libtomcat10-java,
 maven-debian-helper,
 pkgconf,
 quilt,
 unzip,
 zip,
Standards-Version: 4.6.1
Vcs-Git: https://salsa.debian.org/freeipa-team/jss.git
Vcs-Browser: https://salsa.debian.org/freeipa-team/jss
Homepage: https://github.com/dogtagpki/jss

Package: libjss-java
Architecture: any
Depends:
 ${shlibs:Depends},
 ${maven:Depends}
 ${misc:Depends},
Description: Network Security Services for Java
 Network Security Services for Java (JSS) is a Java interface
 to NSS. It supports most of the security standards and
 encryption technologies supported by NSS. JSS also provides
 a pure Java interface for ASN.1 types and BER/DER encoding.

#Package: libjss-tools
#Architecture: any
#Depends: ${shlibs:Depends}, ${misc:Depends},
#Description: Network Security Services for Java -- tools
# Network Security Services for Java (JSS) is a Java interface
# to NSS. It supports most of the security standards and
# encryption technologies supported by NSS. JSS also provides
# a pure Java interface for ASN.1 types and BER/DER encoding.
# .
# This package includes JSS tools.

=== debian/rules ===
--- 
+++ 
@@ -7,23 +7,46 @@
 MOD_MINOR_VERSION := $(word 2, $(subst ., ,$(UPSTREAM_VERSION)))
 MOD_PATCH_VERSION := $(word 3, $(subst ., ,$(UPSTREAM_VERSION)))
 
+override_dh_clean:
+	dh_clean -O--buildsystem=maven
+	dh_clean
+	rm -rf build2/* build2/.targets
+	rm -f org/mozilla/jss/util/jssver.h
+
+override_dh_auto_configure:
+	dh_auto_configure -O--buildsystem=maven
+	dh_auto_configure -O-Bbuild2
+
 override_dh_auto_build:
-	cd build && make all javadoc
+	dh_auto_build -O--buildsystem=maven
 
-override_dh_auto_clean:
+	mkdir -p build2/classes/jss
+	ln -sf ../../../base/target/classes/org build2/classes/jss
+	mkdir -p build2/classes/tests
+	ln -sf ../../../base/target/test-classes/org build2/classes/tests
 
-override_dh_clean:
-	rm -rf build/* build/.targets
-	rm -f org/mozilla/jss/util/jssver.h
-	dh_clean
+	ln -sf ../base/target/jss.jar build2
+	ln -sf ../base/target/jss-tests.jar build2
+
+	mkdir -p build2/include/jss
+	ln -sf ../../../base/target/include/_jni build2/include/jss/_jni
+
+	dh_auto_build -O-Bbuild2
 
 override_dh_auto_install:
-	dh_auto_install --destdir=debian/tmp
+	dh_auto_install -O--buildsystem=maven
+	dh_auto_install -O-Bbuild2 --destdir=debian/tmp
+
+	# tests
 	rm -rf debian/tmp/jss
+
 	rm -rf debian/tmp/usr/share/javadoc
+
 	mkdir -p debian/tmp/usr/share
 	mv debian/tmp/usr/lib/java debian/tmp/usr/share
 	rm -f debian/tmp/usr/lib/jss/*.jar
+
+	rm -f debian/tmp/usr/bin/*
 
 override_dh_auto_test:
 	cd build && ctest --output-on-failure || true
@@ -36,4 +59,4 @@
 		> ../jss_$(UV).orig.tar.xz
 
 %:
-	dh $@ --with quilt --builddirectory=build/
+	dh $@

=== debian/watch ===
Version: 5

Source: https://github.com/dogtagpki/jss/tags/
Matching-Pattern: .*/releases/tag/@ANY_VERSION@
Filename-Mangle: s/@ANY_VERSION@$/jss-$1.tar.gz/
